@ECHO OFF
if "%CommonProgramFiles(x86)%"=="" (goto X86) else (goto X64)
:X86
FOR /F "usebackq" %%t IN (`83 "%ProgramFiles%\BestTech\GCC Developer Lite\GCC\AVR\bin"`) DO SET PATH=%%t
FOR /F "usebackq" %%t IN (`83 "%ProgramFiles%\Atmel\AVR Tools\STK500\stk500.exe"`) DO SET STK=%%t
GOTO INPUT
:X64
FOR /F "usebackq" %%t IN (`83 "%ProgramFiles(x86)%\BestTech\GCC Developer Lite\GCC\AVR\bin"`) DO SET PATH=%%t
FOR /F "usebackq" %%t IN (`83 "%ProgramFiles(x86)%\Atmel\AVR Tools\STK500\stk500.exe"`) DO SET STK=%%t
GOTO INPUT
:INPUT
avr-gcc -mmcu=atmega128 -fno-keep-inline-functions -fno-common -fno-inline-small-functions -fno-tree-scev-cprop -fno-split-wide-types -Wall -Wno-return-type -fno-split-wide-types -fno-inline-small-functions -fno-tree-scev-cprop -DF_CPU=16000000UL -Os -funsigned-char -funsigned-bitfields -fpack-struct -fshort-enums -Wl,-M,--section-start=.text=0x1F800 -Wl,-Map,atmega_bootloader_m128.map atmega_bootloader.c -o atmega_bootloader_m128.elf
@IF ERRORLEVEL 1 GOTO FAIL
@echo TCYmF...
avr-size atmega_bootloader_m128.elf
avr-objcopy --output-target=ihex atmega_bootloader_m128.elf atmega_bootloader_m128.hex
avr-objcopy --output-target=binary atmega_bootloader_m128.elf atmega_bootloader_m128.bin
@IF ERRORLEVEL 1 GOTO FAIL
@GOTO SUCCESS
:FAIL
@ECHO ERROR !!!
@GOTO FIN
:SUCCESS
ECHO COMPLIE OK !!!
ECHO Please push any key when you can prepare the target.
@PAUSE >NUL
%STK% -cUSB -!3686000 -I60000 -dATMEGA128 -s -lCC -Eff -fdcbf -ifatmega_bootloader_m128.hex -pf -vf -LCC -Gff -Fdcbf -e
@IF NOT ERRORLEVEL 1 GOTO DONE
ECHO 
ECHO @s
ECHO 
GOTO FIN:
:DONE
ECHO 
ECHO II
ECHO 
:FIN
PAUSE
