@ECHO OFF
if "%CommonProgramFiles(x86)%"=="" (goto X86) else (goto X64)
:X86
FOR /F "usebackq" %%t IN (`83 "%ProgramFiles%\BestTech\GCC Developer Lite\GCC\AVR\bin"`) DO SET PATH=%%t
FOR /F "usebackq" %%t IN (`83 "%ProgramFiles%\Atmel\AVR Tools\STK500\stk500.exe"`) DO SET STK=%%t
GOTO INPUT
:X64
FOR /F "usebackq" %%t IN (`83 "%ProgramFiles(x86)%\BestTech\GCC Developer Lite\GCC\AVR\bin"`) DO SET PATH=%%t
FOR /F "usebackq" %%t IN (`83 "%ProgramFiles(x86)%\Atmel\AVR Tools\STK500\stk500.exe"`) DO SET STK=%%t
GOTO INPUT
:INPUT
avr-gcc -mmcu=atmega168 -Wall -Wno-return-type -fno-split-wide-types -fno-inline-small-functions -fno-tree-scev-cprop -DF_CPU=16000000UL -Os -funsigned-char -funsigned-bitfields -fpack-struct -fshort-enums -Wl,-M,--section-start=.text=0x3800 -Wl,-Map,atmega_bootloader_m168.map atmega_bootloader.c -o atmega_bootloader_m168.elf
@IF ERRORLEVEL 1 GOTO FAIL
avr-objcopy --output-target=ihex atmega_bootloader_m168.elf atmega_bootloader_m168.hex
avr-objcopy --output-target=binary atmega_bootloader_m168.elf atmega_bootloader_m168.bin
@IF ERRORLEVEL 1 GOTO FAIL
@GOTO SUCCESS
:FAIL
@ECHO ERROR !!!
@GOTO FIN
:SUCCESS
ECHO COMPLIE OK !!!
ECHO Please push any key when you can prepare the target.
@PAUSE >NUL
%STK% -cUSB -!3686000 -I60000 -dATMEGA168 -lCC -Ef8 -fdcff -ms -ifatmega_bootloader_m168.hex -pf -vf -LCC -Gf8 -Fdcff -e
@IF NOT ERRORLEVEL 1 GOTO DONE
ECHO 
ECHO @s
ECHO 
GOTO FIN:
:DONE
ECHO 
ECHO II
ECHO 
:FIN
PAUSE
